#ifndef HASH_FUNC_H_INCLUDED
#define HASH_FUNC_H_INCLUDED


#include "types.h"

// Basic blocks of hash function 

void X_64(u32 *hash, u32 const * data);  // 64 bit data; 64 bit hash
void I_64(u32 *hash, u32 const * data);  // 64 bit data; 64 bit hash
void X_128(u32 *hash, u32 const * data);  // 64 bit data; 128 bit hash
void I_128(u32 *hash, u32 const * data);  // 64 bit data; 128 bit hash


void hash_block_256(u32 *hash, u32 const *data); // 64 bit data; 256 bit hash 

void Hash_Block_X_64(u32 *hash, u8 const* data, u32 data_length_bytes); // 


void Hash_Block_256(u32 *hash, u8 const* data, u32 data_length_bytes); // Any length
void Hash_Block_256(u32 *hash, u32 const* data, u32 data_length_x32); // Any length

// Invertible scrambling and unscrambling

void mix_data(u32 *x, const u32 len_x32, const u32 rounds = 4);
void unmix_data(u32 *x, const u32 len_x32, const u32 rounds = 4);


//void scramble(void *dest, u32 dest_size_bytes, void const *src, u32 src_size_bytes); // scramble dest with source

static void hash_block(u32 *hash, u8 const* data, u32 data_length_bytes, void (*hash_function)(u32 *,u32 *const));

static void mix_128(u32 *x);
static void unmix_128(u32 *x);



//-------------------------------------------
// This gives full 32-bit diffusion in 4 iterations
// Do NOT change -> a lot of things use it
//
static inline u32 k_mix(u32 x)
{
x ^= 0xDF15E92;
x = (x << 5) - x;
x ^= x >> 9;
x = (x << 19) | (x >> 13);
return x;
}


#endif

