#ifndef SERIALIZE_H_INCLUDED
#define SERIALIZE_H_INCLUDED
#include "types.h"

// Convert basic types to/from stream of bytes
// Most significant byte goes first

void u16_to_bytes(u8 *bytes, const u16 x);
void u32_to_bytes(u8 *bytes, const u32 x);
void u64_to_bytes(u8 *bytes, const u64 x);

u16 bytes_to_u16(u8 const* bytes);
u32 bytes_to_u32(u8 const* bytes);
u64 bytes_to_u64(u8 const* bytes);

void serialize_u32(u8 *bytes, u32 const* data, const u32 length_x32); // Convert u32[] to byte[]
void deserialize_u32(u32 *data, u8 const* bytes, const u32 length_x32); // Convert u8[] to u32[]
 


#endif

