#include "..\UPnP\miniwget.h"
#include "..\UPnP\miniupnpc.h"
#include "..\UPnP\upnpcommands.h"
#include "..\UPnP\upnperrors.h"
#include <windows.h>
#include <stdio.h>
#include "types.h"

bool setupUPnP(u16 local_port, u16 external_port, int remove)
{
	char command = 0;
	char ** commandargv = 0;
	int commandargc = 0;
	struct UPNPDev * devlist = 0;
	char lanaddr[64];	// my ip address on the LAN
	char eport[8];
	char iport[8];
	int i;
	int retcode = 0;
	int error = 0;
	const char * description = 0;
	const char proto[] = "UDP";

	if(devlist = upnpDiscover(2000, NULL,NULL,0,0,&error))
	{
		struct UPNPUrls urls;
		struct IGDdatas data;
		if(i = UPNP_GetValidIGD(devlist, &urls, &data, lanaddr, sizeof(lanaddr)))
		{
			char externalIPAddress[40];
			char intClient[40];
			char intPort[6];

			UPNP_GetExternalIPAddress(urls.controlURL,data.first.servicetype,externalIPAddress);

			sprintf(eport,"%d",external_port);
			sprintf(iport,"%d",local_port);
			if (remove)
			{
				i = UPNP_DeletePortMapping(urls.controlURL, data.first.servicetype, eport, proto, 0);
			}
			else
			{
				i = UPNP_AddPortMapping(urls.controlURL,data.first.servicetype,eport,iport,lanaddr,NULL,proto,NULL,"0");
				i = UPNP_GetSpecificPortMappingEntry(urls.controlURL,data.first.servicetype,eport,proto,intClient, intPort,NULL,NULL,NULL);
			}
			FreeUPNPUrls(&urls);
		}
		else
		{
			freeUPNPDevlist(devlist);
			return false;
		}
		freeUPNPDevlist(devlist);
		return (i==UPNPCOMMAND_SUCCESS);
	}
	return false;
}
