#ifndef USERS_H_INCLUDED
#define USERS_H_INCLUDED
//-----------------------------------------------------------------------
#include "cp_threads.h"
#include "cp_strop.h"
#include "pugixml.h"
#include "kademlia.h"
#include "cp_time.h"
#include "types.h"
using namespace pugi;
//-----------------------------------------------------------------------
typedef struct user {
	NODE nd;
	cp_time_t last_seen;
	ptstr_t url;
	struct user *next;
} user_t;
//-----------------------------------------------------------------------
typedef struct like {
	NODE nd;
	ptstr_t name;
	struct like *next;
} like_t;
//-----------------------------------------------------------------------
class KADEMLIA;
//-----------------------------------------------------------------------
class USERS {
	lock_t lock;
	user_t* users;
	like_t* likes;

	void _append_user(user_t *new_user);

public:
	USERS();
	~USERS();

	void update_node(const NODE* nd);
	void load_nodes(KADEMLIA* kad, pctstr_t filename);
	void save_nodes(pctstr_t filename);

	void load_likes(pctstr_t filename);
	void save_likes(pctstr_t filename);
	void append_like(NODE* nd, pctstr_t name);
	void remove_like(u32* id);
	like_t* getLikes(void) {return likes;};
};
//-----------------------------------------------------------------------
void id2str(const u32 *id, ptstr_t str);
bool str2id(pctstr_t str, u32 *id);
void ip2str(const u32 ip, ptstr_t str);
bool str2ip(pctstr_t str, u32 *ip);
//-----------------------------------------------------------------------
#endif //USERS_H_INCLUDED
